/*! Copyright 2013 Amazon Digital Services, Inc. All rights reserved. */
APICallHandler=(function(){var d=function(q,n,p){var s=q;var r=n;var m=p;var o="APICall";this["getHandledType"]=function(){return o};this["handleRequest"]=function(v){var R=$.Deferred();if(!(v instanceof Request)){console.log("APICallHandler: handleRequest: input was not of type Request");var G=new Result(constants.NativeCallResultCode.ERROR,{});R.resolve(G)}else{var u=v.getType();var S=v.getParams();console.log("APICallHandler: handleRequest: message is: "+JSON.stringify(S));var x=""+S[constants.ServiceActionCode.ACTION_CODE_KEY];var H={};switch(x){case constants.ServiceActionCode.AUTHORIZE_SESSION:s.onInitialize();s.getInitializationPromise().always(function(){var T={};T[constants.BindingKeys.AUTHORIZE_RESULT_BUNDLE_KEY]=constants.AuthorizeKeys.AUTHORIZED;var U=constants.NativeCallResultCode.SUCCESS;var V=new Result(U,T);R.resolve(V)});break;case constants.ServiceActionCode.START_SESSION:r.startSession(S[constants.BindingKeys.REQUEST_TIMESTAMP]);s.startSession();var L=new Result(constants.NativeCallResultCode.SUCCESS,{});R.resolve(L);break;case constants.ServiceActionCode.STOP_SESSION:r.stopSession(S[constants.BindingKeys.REQUEST_TIMESTAMP]);var L=new Result(constants.NativeCallResultCode.SUCCESS,{});R.resolve(L);break;case constants.ServiceActionCode.SHOW_SIGN_IN_PAGE:s.showSignInPage();var L=new Result(constants.NativeCallResultCode.SUCCESS,{});R.resolve(L);break;case constants.ServiceActionCode.SHOW_TOS_PAGE:s.showOverlay(constants.OverlayActionCode.SHOW_TERMS_OF_SERVICE);var L=new Result(constants.NativeCallResultCode.SUCCESS,{});R.resolve(L);break;case constants.ServiceActionCode.SET_OPT_IN:var w=S[constants.NativeCallKeys.HAS_OPTED_IN];s.setOptIn(w);L=new Result(constants.NativeCallResultCode.SUCCESS,{});R.resolve(L);break;case constants.ServiceActionCode.AUTHENTICATE:s.authenticate();var L=new Result(constants.NativeCallResultCode.SUCCESS,{});R.resolve(L);break;case constants.ServiceActionCode.UPDATE_COUNTRY_OF_RESIDENCE:s.updateCOR(v.getParams()[constants.BindingKeys.COUNTRY_OF_RESIDENCE]);var L=new Result(constants.NativeCallResultCode.SUCCESS,{});R.resolve(L);break;case constants.ServiceActionCode.IS_WHISPERSYNC_ENABLED:m.getGuestMode().always(function(T){m.isKindle().always(function(V){var U=$.Deferred();if(V){m.isKindleWhispersyncSettingEnabled().always(function(W){U.resolve(W)})}else{m.getWhispersyncEnabledUserSetting().always(function(W){U.resolve(W)})}U.always(function(X){var W={};if(T||!X){W[constants.BindingKeys.WHISPERSYNC_ENABLED]=false}else{W[constants.BindingKeys.WHISPERSYNC_ENABLED]=true}var Y=new Result(constants.NativeCallResultCode.SUCCESS,W);R.resolve(Y)})})});break;case constants.ServiceActionCode.SHOW_OVERLAY_ACHIEVEMENTS:var Q={};Q[constants.OverlayBindingKeys.OVERLAY_ACTION_CODE_KEY]=constants.OverlayActionCode.SHOW_ACHIEVEMENTS;hostinterface.showOverlay(JSON.stringify(Q));break;case constants.ServiceActionCode.SHOW_OVERLAY_PROFILE:var Q={};Q[constants.OverlayBindingKeys.OVERLAY_ACTION_CODE_KEY]=constants.OverlayActionCode.SHOW_PROFILE;hostinterface.showOverlay(JSON.stringify(Q));break;case constants.ServiceActionCode.SHOW_OVERLAY_LEADERBOARDS:var Q={};Q[constants.OverlayBindingKeys.OVERLAY_ACTION_CODE_KEY]=constants.OverlayActionCode.SHOW_LEADERBOARDS;hostinterface.showOverlay(JSON.stringify(Q));break;case constants.ServiceActionCode.SHOW_OVERLAY_RANKS:var Q={};Q[constants.OverlayBindingKeys.OVERLAY_ACTION_CODE_KEY]=constants.OverlayActionCode.SHOW_LEADERBOARD_RANKS;Q[constants.LeaderboardBindingKeys.LEADERBOARD_ID_KEY]=v.getParams()[constants.LeaderboardBindingKeys.LEADERBOARD_ID_KEY];hostinterface.showOverlay(JSON.stringify(Q));break;case constants.ServiceActionCode.SHOW_GAME_CIRCLE:case constants.ServiceActionCode.SHOW_OVERLAY_SUMMARY:var Q={};Q[constants.OverlayBindingKeys.OVERLAY_ACTION_CODE_KEY]=constants.OverlayActionCode.SHOW_SUMMARY;hostinterface.showOverlay(JSON.stringify(Q));var L=new Result(constants.NativeCallResultCode.SUCCESS,{});R.resolve(L);break;case constants.ServiceActionCode.HANDLE_TOAST_CLICK:var H={};var F=v.getParams()[constants.ToastKeys.ACTION_MAPPINGS_KEY];var P=v.getParams()[constants.ToastKeys.TOAST_CLICK_DATA_KEY];var O=ServiceFactory.getRequestFactory().createToastClickRequest(F,P);ServiceFactory.getRequestRouter().handleRequest(O).always(function(T){R.resolve({})});break;case constants.ServiceActionCode.HANDLE_TOAST_DISPLAY_METRIC:var H={};var B=v.getParams()[constants.ToastKeys.TOAST_REQUEST_DISPLAYED];var E=ServiceFactory.getRequestFactory().createToastMetricRequest(B);ServiceFactory.getRequestRouter().handleRequest(E).always(function(T){R.resolve({})});break;case constants.ServiceActionCode.PROCESS_OFFLINE_EVENT:var H={};var z=ServiceFactory.getRequestFactory().createProcessOfflineEventRequest(v.getParams()["jsonEvent"]);ServiceFactory.getRequestRouter().handleRequest(z).always(function(T){R.resolve(k(T))});break;case constants.ServiceActionCode.REQUEST_ACHIEVEMENT:var K=ServiceFactory.getRequestFactory().createGetAchievementRequest(v.getParams()["ACHIEVEMENT_ID"],false);var J=ServiceFactory.getRequestRouter().handleRequest(K);J.done(function(T){R.resolve(i(T))});break;case constants.ServiceActionCode.REQUEST_ACHIEVEMENTS:var N=ServiceFactory.getRequestFactory().createGetAchievementsRequest(false);var J=ServiceFactory.getRequestRouter().handleRequest(N);J.done(function(T){R.resolve(b(T))});break;case constants.ServiceActionCode.UPDATE_ACHIEVEMENT_PROGRESS:var y=ServiceFactory.getRequestFactory().createUpdateAchievementsRequest(v.getParams()["ACHIEVEMENT_ID"],v.getParams()["ACHIEVEMENT_UPDATE_PERCENT"]);var J=ServiceFactory.getRequestRouter().handleRequest(y);J.done(function(T){R.resolve(g(T))});break;case constants.ServiceActionCode.REQUEST_LEADERBOARDS:var A=ServiceFactory.getRequestFactory().createGetLeaderboardsForGameRequest(v.getParams()["GAME_ID"],false);var J=ServiceFactory.getRequestRouter().handleRequest(A);J.done(function(T){R.resolve(l(T))});break;case constants.ServiceActionCode.REQUEST_PLAYER_SCORE:var t=ServiceFactory.getRequestFactory().createGetHighScoreRequest(v.getParams()["GAME_ID"],v.getParams()["LEADERBOARD_ID"],v.getParams()["LEADERBOARD_FILTER"],false);var J=ServiceFactory.getRequestRouter().handleRequest(t);J.done(function(T){R.resolve(e(T))});break;case constants.ServiceActionCode.REQUEST_SCORES:v.getParams()["LEADERBOARD_START_RANK"]=1;v.getParams()["LEADERBOARD_SCORES_COUNT"]=100;var D=ServiceFactory.getRequestFactory().createGetLeaderboardRanksRequest(v.getParams()["GAME_ID"],v.getParams()["LEADERBOARD_ID"],v.getParams()["LEADERBOARD_FILTER"],v.getParams()["LEADERBOARD_START_RANK"],v.getParams()["LEADERBOARD_SCORES_COUNT"],false,false);var J=ServiceFactory.getRequestRouter().handleRequest(D);J.done(function(T){R.resolve(f(T,v.getParams()["LEADERBOARD_START_RANK"]))});break;case constants.ServiceActionCode.REQUEST_PERCENTILES:var C=ServiceFactory.getRequestFactory().createGetLeaderboardPercentilesRequest(v.getParams()["GAME_ID"],v.getParams()["LEADERBOARD_ID"],v.getParams()["LEADERBOARD_FILTER"],false,false);var J=ServiceFactory.getRequestRouter().handleRequest(C);J.done(function(T){R.resolve(h(T))});break;case constants.ServiceActionCode.SUBMIT_SCORE:var I=ServiceFactory.getRequestFactory().createSubmitScoreRequest(v.getParams()["LEADERBOARD_ID"],v.getParams()["LEADERBOARD_SUBMIT_SCORE"]);var J=ServiceFactory.getRequestRouter().handleRequest(I);J.done(function(T){R.resolve(c(T,v.getParams()["LEADERBOARD_SUBMIT_SCORE"]))});break;case constants.ServiceActionCode.REQUEST_LOCAL_PLAYER_PROFILE:var M=ServiceFactory.getGCSettings().getGuestMode();M.always(function(T){if(T){var U={};U[constants.BindingKeys.REQUEST_ID_KEY]=v.getParams()[constants.BindingKeys.REQUEST_ID_KEY];U[constants.ServiceResponseCode.RESPONSE_CODE_KEY]=constants.ServiceResponseCode.NOT_AUTHENTICATED;hostinterface.sendReply(JSON.stringify(U))}else{var W=ServiceFactory.getRequestFactory().createGetProfileRequest(false);var V=ServiceFactory.getRequestRouter().handleRequest(W);V.always(function(X){var Z=X.getResultMap();if(Z.hidden){var Y={};Y[constants.BindingKeys.REQUEST_ID_KEY]=v.getParams()[constants.BindingKeys.REQUEST_ID_KEY];Y[constants.ServiceResponseCode.RESPONSE_CODE_KEY]=constants.ServiceResponseCode.NOT_AUTHENTICATED;hostinterface.sendReply(JSON.stringify(Y))}else{var Y={};Y[constants.BindingKeys.REQUEST_ID_KEY]=v.getParams()[constants.BindingKeys.REQUEST_ID_KEY];if($.isEmptyObject(Z)){Y[constants.ServiceResponseCode.RESPONSE_CODE_KEY]=constants.ServiceResponseCode.SERVICE_REQUEST_FAILURE}else{Y[constants.ServiceResponseCode.RESPONSE_CODE_KEY]=constants.ServiceResponseCode.SERVICE_REQUEST_SUCCESS;Y[constants.ProfilesBindingKeys.ALIAS_KEY]=Z.alias;Y[constants.ProfilesBindingKeys.PLAYER_ID_KEY]=Z.playerId;Y[constants.ProfilesBindingKeys.AVATAR_URL_KEY]=Z.avatarUrl}hostinterface.sendReply(JSON.stringify(Y))}})}});break;default:console.log("Message not supported what="+x);console.log("APICallHandler: handleRequest: actionCode not supported");var G=new Result(constants.NativeCallResultCode.ERROR,{});R.resolve(G)}}console.log("End of API handler call");return R.promise()}};var k=function(m){var n={};var o=constants.NativeCallResultCode.ERROR;if(m instanceof Result){o=m.getType()}var p=new Result(o,n);return p};var a=function(n,p){var m={};if(n!==undefined&&p!==undefined&&n&&p){m[constants.AchievementsBindingKeys.ACHIEVEMENT_ID_KEY]=n.id;m[constants.AchievementsBindingKeys.ACHIEVEMENT_TITLE_KEY]=n.title;m[constants.AchievementsBindingKeys.ACHIEVEMENT_DESCRIPTION_KEY]=n.description;m[constants.AchievementsBindingKeys.ACHIEVEMENT_POINTS_KEY]=n.pointValue;m[constants.AchievementsBindingKeys.ACHIEVEMENT_HIDDEN_KEY]=n.hiddenValue;m[constants.AchievementsBindingKeys.ACHIEVEMENT_POSITION_KEY]=n.position;m[constants.AchievementsBindingKeys.ACHIEVEMENT_UNLOCKED_KEY]=p.unlocked;m[constants.AchievementsBindingKeys.ACHIEVEMENT_UPDATE_PERCENT_KEY]=p.progress;if(m[constants.AchievementsBindingKeys.ACHIEVEMENT_UNLOCKED_KEY]){m[constants.AchievementsBindingKeys.ACHIEVEMENT_DATE_UNLOCKED_KEY]=p.dateUnlocked;m[constants.AchievementsBindingKeys.ACHIEVEMENT_ICON_URL_LARGE_KEY]=n.largeIconUrl}else{m[constants.AchievementsBindingKeys.ACHIEVEMENT_DATE_UNLOCKED_KEY]=0;m[constants.AchievementsBindingKeys.ACHIEVEMENT_ICON_URL_LARGE_KEY]=n.lockedLargeIconUrl}for(var o in m){if(m.hasOwnProperty(o)&&(m[o]===undefined||m[o]===null)){m={error:"error"};break}}}else{m={error:"error"}}return m};var b=function(m){var o={};var r=constants.NativeCallResultCode.ERROR;if(m instanceof Result&&m.getType()===constants.NativeCallResultCode.SUCCESS){r=constants.NativeCallResultCode.SUCCESS;var n=[];var q=m.getResultMap()["achievements"]||null;var p=q&&q.achievements;if(Array.isArray(p)){$.each(p,function(u,v){var t=v.achievementMeta;var w=v.playerInfo;var s=a(t,w);if(s.hasOwnProperty("error")){r=constants.NativeCallResultCode.ERROR}n.push(s)})}else{r=constants.NativeCallResultCode.ERROR}if(r===constants.NativeCallResultCode.SUCCESS){o[constants.AchievementsBindingKeys.ACHIEVEMENT_LIST_KEY]=n}}return new Result(r,o)};var i=function(m){var n={};var p=constants.NativeCallResultCode.ERROR;if(m instanceof Result&&m.getType()===constants.NativeCallResultCode.SUCCESS){p=constants.NativeCallResultCode.SUCCESS;var o=m.getResultMap()["achievement"]||null;if(o){n=a(o.achievementMeta,o.playerInfo);if(n.hasOwnProperty("error")){p=constants.NativeCallResultCode.ERROR;n={}}}else{p=constants.NativeCallResultCode.ERROR;n={}}}return new Result(p,n)};var g=function(m){var n={};var o=constants.NativeCallResultCode.ERROR;if(m instanceof Result&&m.getType()===constants.NativeCallResultCode.SUCCESS){o=constants.NativeCallResultCode.SUCCESS;n[constants.AchievementsBindingKeys.ACHIEVEMENT_NEWLY_UNLOCKED_KEY]=m.getResultMap()["newlyUnlocked"];if(n[constants.AchievementsBindingKeys.ACHIEVEMENT_NEWLY_UNLOCKED_KEY]===undefined||n[constants.AchievementsBindingKeys.ACHIEVEMENT_NEWLY_UNLOCKED_KEY]===null){o=constants.NativeCallResultCode.ERROR;n={}}}return new Result(o,n)};var j=function(n){var m={};if(n!==undefined&&n){m[constants.LeaderboardBindingKeys.LEADERBOARD_DISPLAY_TEXT_KEY]=n.DisplayText;m[constants.LeaderboardBindingKeys.LEADERBOARD_ID_KEY]=n.LeaderboardId;m[constants.LeaderboardBindingKeys.LEADERBOARD_NAME_KEY]=n.Name;m[constants.LeaderboardBindingKeys.LEADERBOARD_DATA_FORMAT_KEY]=n.DataFormat;m[constants.LeaderboardBindingKeys.LEADERBOARD_ICON_URL_KEY]=n.IconUrl;for(var o in m){if(m.hasOwnProperty(o)&&(m[o]===undefined||m[o]===null)){m={error:"error"};break}}}else{m={error:"error"}}return m};var l=function(n){var p={};var q=constants.NativeCallResultCode.ERROR;if(n instanceof Result&&n.getType()===constants.NativeCallResultCode.SUCCESS){q=constants.NativeCallResultCode.SUCCESS;var o=[];var m=n.getResultMap()["LeaderboardList"]||null;if(m){$.each(m,function(t,s){var r=j(s.LeaderboardInfo);if(r.hasOwnProperty("error")){q=constants.NativeCallResultCode.ERROR}else{o.push(r)}})}else{q=constants.NativeCallResultCode.ERROR}if(q===constants.NativeCallResultCode.SUCCESS){p[constants.LeaderboardBindingKeys.LEADERBOARD_LIST_KEY]=o}}return new Result(q,p)};var e=function(m){var n={};var p=constants.NativeCallResultCode.ERROR;if(m instanceof Result&&m.getType()===constants.NativeCallResultCode.SUCCESS){p=constants.NativeCallResultCode.SUCCESS;n[constants.LeaderboardBindingKeys.LEADERBOARD_SUBMIT_SCORE_KEY]=m.getResultMap()["PlayerScore"];n[constants.LeaderboardBindingKeys.LEADERBOARD_PLAYER_RANK_KEY]=m.getResultMap()["PlayerRank"];for(var o in n){if(n.hasOwnProperty(o)&&(n[o]===undefined||n[o]===null)){p=constants.NativeCallResultCode.ERROR;n={};break}}}return new Result(p,n)};var f=function(u,n){var q=function(v,x){var y={scoreList:[]};if(v===undefined||v===null||typeof v!=="object"||x===undefined||typeof x!=="number"){y={error:"error"}}else{var w=x;$.each(v,function(A,z){var C={};C[constants.LeaderboardBindingKeys.LEADERBOARD_SCORE_VALUE_KEY]=z.Score;C[constants.LeaderboardBindingKeys.LEADERBOARD_KEY]=z.Score;C[constants.LeaderboardBindingKeys.LEADERBOARD_SCORE_RANK_KEY]=w;C[constants.ProfilesBindingKeys.ALIAS_KEY]=z.Username;C[constants.ProfilesBindingKeys.PLAYER_ID_KEY]=z.PlayerId;C[constants.ProfilesBindingKeys.AVATAR_URL_KEY]=z.AvatarUrl||"";y.scoreList.push(C);w++;for(var B in C){if(C.hasOwnProperty(B)&&(C[B]===undefined||C[B]===null)){y.error="error";break}}})}return y};var m={};var t=constants.NativeCallResultCode.ERROR;if(u instanceof Result&&u.getType()===constants.NativeCallResultCode.SUCCESS){t=constants.NativeCallResultCode.SUCCESS;var p=j(u.getResultMap()["LeaderboardInfo"]);var r=q(u.getResultMap()["RankList"],n);var o=!r.hasOwnProperty("error")&&!p.hasOwnProperty("error");o=o&&r.hasOwnProperty("scoreList")&&Array.isArray(r.scoreList);if(o){for(var s in p){if(p.hasOwnProperty(s)){m[s]=p[s]}}m[constants.LeaderboardBindingKeys.LEADERBOARD_SCORES_ARRAY_KEY]=r.scoreList}else{t=constants.NativeCallResultCode.ERROR}}return new Result(t,m)};var h=function(u){var q=function(v){var w={percentileList:[]};if(v===undefined||v===null||typeof v!=="object"){w={error:"error"}}else{$.each(v,function(x,A){var z={};z[constants.LeaderboardBindingKeys.LEADERBOARD_PERCENTILE_KEY]=A.Percentile;z[constants.LeaderboardBindingKeys.LEADERBOARD_PERCENTILE_PLAYER_SCORE_KEY]=A.PlayerScore;z[constants.LeaderboardBindingKeys.LEADERBOARD_PERCENTILE_PLAYER_NAME_KEY]=A.PlayerName;z[constants.LeaderboardBindingKeys.LEADERBOARD_PERCENTILE_PLAYER_ID_KEY]=A.PlayerId;z[constants.LeaderboardBindingKeys.LEADERBOARD_PERCENTILE_PLAYER_AVATAR_URL_KEY]=A.AvatarUrl||"";for(var y in z){if(z.hasOwnProperty(y)&&(z[y]===undefined||z[y]===null)){w.error="error";break}}w.percentileList.push(z)})}return w};var n={};var t=constants.NativeCallResultCode.ERROR;if(u instanceof Result&&u.getType()===constants.NativeCallResultCode.SUCCESS){t=constants.NativeCallResultCode.SUCCESS;var p=j(u.getResultMap()["LeaderboardInfo"]);var r=q(u.getResultMap()["PercentileList"]);var m=u.getResultMap()["UserIndex"];var o=!r.hasOwnProperty("error")&&!p.hasOwnProperty("error");o=o&&r.hasOwnProperty("percentileList")&&Array.isArray(r.percentileList);o=o&&m!==undefined&&typeof m==="number";if(o){for(var s in p){if(p.hasOwnProperty(s)){n[s]=p[s]}}n[constants.LeaderboardBindingKeys.LEADERBOARD_PERCENTILES_ARRAY_KEY]=r.percentileList;n[constants.LeaderboardBindingKeys.LEADERBOARD_USER_INDEX_KEY]=m}else{t=constants.NativeCallResultCode.ERROR}}return new Result(t,n)};var c=function(m){var n={};var p=constants.NativeCallResultCode.ERROR;if(m instanceof Result&&m.getType()===constants.NativeCallResultCode.SUCCESS){p=constants.NativeCallResultCode.SUCCESS;var o=m.getResultMap()["SubmitScoreResultsList"]||null;if(o){n[constants.LeaderboardBindingKeys.LEADERBOARD_SUBMIT_RESULT_KEY]=o}else{p=constants.NativeCallResultCode.ERROR}}return new Result(p,n)};return d}());console.log("APICallHandler loaded.");